class Game{
    constructor(name){
        this.name = name;
        this.files = [];
    }
    loadVerionInfo(callback){
        console.log("fetching version informations......")
        
        // $.post("https://www.babyhazelgames.com/html5/test/versionInfo.php",{"gamename": this.name},callback);
        $.post("https://www.babyhazelgames.com/html5/VersionInfo/versionInfo.php",{"gamename": this.name},callback);
        // $.post("http://192.168.0.57/bhatbeach/versionInfo.php",{"gamename": this.name},callback);
    }
    setVersion(version){
        this.version = version;
    };
    getVersion(){
        return this.version;
    };
    getFileVersion(fileName){
        for(let i=0; i<this.files; i++){
            if(this.files[i].getName() == fileName){
                return file[i].getVersion();
            }
        }
        return null;
    } 
    
    getFiles(){
        this.files;
    }
    getFile(fileName){
        if(isNaN(fileName)){
        for(let i = 0; i<this.files.length; i++){
            if(this.files[i].name == fileName){
                return this.files[i]
            }
        }
        }
        else{ 
            if(this.files.length>fileName)
            return this.files[fileName];
        }
        return null;
    }
    addFile(file)  {
        this.files.push(file)
    }
    
    removeFile(fileName){
        if(isNaN(fileName)){
          for(let i = 0; i<this.files.length; i++){
                if(this.files[i].name == fileName){
                    this.files.splice(i, 1)
                    break;
                }
            }
        }
        else
        {
            if(this.files.length>fileName) this.files.splice(fileName, 1)
        }
    }
    
    //Listener on filesVersion loading complete
    onLoadVersionInfo(manifest){
        console.log(manifest)
		manifest = JSON.parse(manifest)
        let common_game_manifest = manifest[0].commonFiles;   
    	let game_manifest = manifest[0].gameInfo;
		console.log("game_manifest", game_manifest);
    	let gameFiles = game_manifest[0].gameFiles;
    	game.version = game_manifest[0].version;
        for(let i = 0; i<common_game_manifest.length; i++){
            let file = new CustomFile(common_game_manifest[i].name, common_game_manifest[i].version, common_game_manifest[i].path, common_game_manifest[i].type);
            game.addFile(file) ;
        }
        for(let i = 0; i<gameFiles.length; i++){
            let file = new CustomFile(gameFiles[i].name, gameFiles[i].version, gameFiles[i].path, gameFiles[i].type);
            game.addFile(file);
        }
        init();
    }




}

class CustomFile {
    constructor(name, version, path, type){
        this.name = name;
        this.version = version;
        this.path = path;
        this.type = type;        
    }

    setVerion(version){
        this.version = this.version;
    }
    setPath(path){
        this.path = this.path;
    }
    setName(name){
        this.name = name
    }
    getName(){
        return this.name;
    }
    getPath(){
        return this.path;
    }
    getVersion(){
        return this.version;
    }
}


var isInstantGames = false
var gameContainer,canvas, splashContainer, preloader_hazelContainer, anim_container, dom_overlay_container, progress_count, portraitDiv;
var deviceWidth, deviceHeight, aspectRatio, fullScreenMode, gameMode;
var isAdBlocker = false;
var detectDevice = "windows";
var isMobile;
var images = [] || {};
var showLink = true;
var fb_Link = true;
var youtube_Link = true;
var bhglogo_Link = true;
var circlelogo_Link = true;

function init() {
    if(isAdBlocker)
        return;
    isInstantGames = false;
    gameContainer = document.getElementById("container");	// used for grey background of cover page
    canvas = document.getElementById("canvas");
    splashContainer = document.getElementById("splash-screen");
    preloader_hazelContainer = document.getElementById("preloader_hazel");
    anim_container = document.getElementById("animation_container");
    dom_overlay_container = document.getElementById("dom_overlay_container");
    //progress_bar = document.getElementById("progress-bar");
    progress_count = document.getElementById("progress_count");
    portraitDiv = document.getElementById("portraitHint");
    portraitDiv.style.display = 'none';
    if(!isInstantGames){
        initGame();
    } else {
        preloader_hazelContainer.style.display = 'none';
        FBInstant.initializeAsync().then(function() {
            initGame();
        });
    }
}
function initGame(){
    
    //console.log("-- init Game called --");
    fullScreenMode = false;
    deviceWidth = screen.width;
    deviceHeight = screen.height;
    aspectRatio = deviceWidth/deviceHeight;
    
    isMobile = /iPhone|iPad|iPod|Android/i.test(navigator.userAgent);
   loadAllFiles(game);
    getMobileOperatingSystem();
    screenfull.on('change', () => {
        //console.log('Am I fullscreen?', screenfull.isFullscreen ? 'Yes' : 'No');
        if(detectDevice != "IOS"){
            if (screenfull.isFullscreen){
                fullScreenMode = true;
                makeResponsive(true,'both',true,3);	
                toogleFullScreenBtn();
                //console.log("_______________FullScreen");
            }else{
                fullScreenMode = false;
                makeResponsive(true,'both',true,1);	
                toogleFullScreenBtn();
                //console.log("_______________FullScreen");
            }
        }
    });
    if (screenfull.enabled) {
        screenfull.on('error', event => {
            alert('Please try after sometime');
        });
    }
}
function loadAllFiles(customGame){
    $.getJSON("manifest.json?v="+ customGame.getFile("manifest.json").getVersion()+"."+customGame.version, loadFiles);
    function loadFiles(assets){
        images = images||{};
        var manifest = assets.image_manifest;
        var sound_manifest = assets.sound_manifest;
        var loader = new createjs.LoadQueue(true);	
        let files = customGame.files;
        var loader = new createjs.LoadQueue(true);	
        
        //console.log(window.innerHeight,window.outerHeight, window.height,$(window).height(), "XXX");
        loader.setMaxConnections(20);
        loader.installPlugin(createjs.Sound);
        loader.addEventListener("progress", handleProgress);
        loader.addEventListener("fileload", handleFileLoad);
        loader.addEventListener("complete", handleComplete);
        for(var i = 0; i<files.length; i++){
            let version01 = files[i].version+"."+customGame.version;
            console.log(version01);
            if( files[i].type.toUpperCase() ==  "JAVASCRIPT")
				loader.loadFile({ src: files[i].path+'?v='+version01, type: createjs.Types.JAVASCRIPT }, false);
        }
        loader.loadManifest(sound_manifest, false);
        loader.loadManifest(manifest, false);
        loader.load();
    }    
}
function handleProgress(progress) {
    var loadedPercent = progress.loaded * 100;
    if(isInstantGames){
        FBInstant.setLoadingProgress(loadedPercent);
    }else{
        progress_count.innerHTML = Math.floor(loadedPercent) + '%';
    }

}
var count = 0;
function handleFileLoad(evt) {
    //console.log("handle file loaded: " + evt.item.src);
    
    if(evt.item.type == createjs.Types.JAVASCRIPT){
        var head = document.getElementsByTagName('head');
        head[0].append(evt.result);	
        console.log("Javascript Completed");
    }
    if (evt.item.type == "image") { 
        count++;
        //console.log(count);
        images[evt.item.id] = evt.result; 
    }	

}
function handleComplete(evt) {
    //GameAnalytics("setEnabledInfoLog", true);
    //GameAnalytics("setEnabledVerboseLog", true);
    //GameAnalytics("configureBuild", "0.10");
    if(!isInstantGames) {
        
        try {
            
            initAd();
        } catch(err) {
            document.getElementById("adContent").style.display = "none";
            if(isSound && active  && lockGame == null) {
                createjs.Sound.volume = 1;
            }
            //console.log("Ad error called FROM INIT GAME: " + err);
        }
    }
    //This function is always called, irrespective of the content. You can use the variable "stage" after it is created in token create_stage.
    console.log("-- handleComplete called --");
    var queue = evt.target;
    i=0;
    var progressDiv = document.getElementById("progress_div");

    progressDiv.style.display = 'none';
    preloader_hazelContainer.style.display = 'none';

    canvas.style.display = 'block';

    splashContainer.style.display = 'block';
    
    $("#playBtnImg").click(onClick);
    $("playBtnImg").mousedown(function(){
        return false;
    });
    $("#blackpatch").click(onTap);

    showBlackPatch(1);

    exportRoot = new lib.AfricanSafari();

    stage = new createjs.Stage(canvas);

    stage.addChild(exportRoot);

    stage.enableMouseOver();

    $("#container").css({
        'background':'-webkit-linear-gradient(left,#708A7D, #A87E66, #708A7D)',        
    });

    //Registers the "tick" event listener.

    fnStartAnimation = function() {
        createjs.Ticker.framerate = lib.properties.fps;
        createjs.Ticker.addEventListener("tick", stage);

    }	    
    if (isInstantGames) {
        FBInstant.startGameAsync().then(function () {
            var supportedAPIs = FBInstant.getSupportedAPIs();

            if (supportedAPIs.includes('getInterstitialAdAsync') && supportedAPIs.includes('getRewardedVideoAsync')) {
                loadInterstitial();
                loadRewardVideo();
                console.log("Ads loaded");
            } else {
                console.log('Ads not supported in this session');
            }
        });
    }
    //Code to support hidpi screens and responsive scaling.
    makeResponsive = function(isResp, respDim, isScale, scaleType) {	
        var lastW, lastH, lastS=1;	
        window.removeEventListener('resize', resizeCanvas);
        window.addEventListener('resize', resizeCanvas);		
        resizeCanvas();		
        function resizeCanvas() {	
            setTimeout(function() {		
                var w = lib.properties.width, h = lib.properties.height;			
                var iw = window.innerWidth, ih=window.innerHeight;			
                var pRatio = window.devicePixelRatio || 1, xRatio=iw/w, yRatio=ih/h, sRatio=1;		
                if (scaleType == 3) {
                    canvas.width = w*pRatio*xRatio;
                    canvas.height = h*pRatio*yRatio;
                    canvas.style.width = anim_container.style.width = preloader_hazelContainer.style.width = dom_overlay_container.style.width = portraitDiv.style.width = splashContainer.style.width = w*xRatio + 'px';
                    canvas.style.height = anim_container.style.height = preloader_hazelContainer.style.height = dom_overlay_container.style.height = splashContainer.style.height = portraitDiv.style.height = h*yRatio + 'px';
                    stage.scaleX = pRatio*xRatio;
                    stage.scaleY = pRatio*yRatio;
                    lastW = iw; lastH = ih; lastS = sRatio;
                } else {
                    if(isResp) {                
                        if((respDim=='width'&&lastW==iw) || (respDim=='height'&&lastH==ih)) {                    
                            sRatio = lastS;                
                        }				
                        else if(!isScale) {					
                            if(iw<w || ih<h)						
                                sRatio = Math.min(xRatio, yRatio);				
                        }				
                        else if(scaleType==1) {					
                            sRatio = Math.min(xRatio, yRatio);				
                        }				
                        else if(scaleType==2) {					
                            sRatio = Math.max(xRatio, yRatio);				
                        }			
                    }			
                    canvas.width = w*pRatio*sRatio;			
                    canvas.height = h*pRatio*sRatio;
                    canvas.style.width = anim_container.style.width = preloader_hazelContainer.style.width = dom_overlay_container.style.width = portraitDiv.style.width = splashContainer.style.width = w*sRatio+'px';				

                    canvas.style.height = anim_container.style.height = preloader_hazelContainer.style.height = dom_overlay_container.style.height = splashContainer.style.height = portraitDiv.style.height = h*sRatio+'px';
                    stage.scaleX = pRatio*sRatio;			
                    stage.scaleY = pRatio*sRatio;			
                    lastW = iw; lastH = ih; lastS = sRatio;	
                }
                if(gameContainer.offsetHeight > gameContainer.offsetWidth){
                    gameMode = "portrait";
                    portraitDiv.style.display = 'block';
                    splashContainer.style.display = 'none';
                    showBlackPatch(1);
                    if(lockGame == null){
                        //console.log("Orientation change: Portrait");
                        lockGame = 1;
                        createjs.Sound.volume = 0.0001;
                        showBlackPatch(1);
                    }
                }else{
                    //console.log("Orientation change: Landscape");
                    gameMode = "landscape";
                    portraitDiv.style.display = 'none';
                    if(!gameStarted){
                        splashContainer.style.display = 'block';
                        $("#container").css({
                            'background':'-webkit-linear-gradient(left,#708A7D, #A87E66, #708A7D)',            
                        });
                    }
                    if(lockGame != null){
                        lockGame = null;
                        $('html').css("background-image", "url(\"\")");
                        if (isSound && !isAdPlaying && active && !Paused) {
                            //console.log("Sound turned ON");
                            createjs.Sound.volume = 1;
                        } else {
                            //console.log("Sound turned OFF");
                            createjs.Sound.volume = 0.0001;
                        }
                        if(Paused) {
                            showBlackPatch(2);
                        }
                    }
                }
            }, 100);
        }
    }
    if(isMobile)
        makeResponsive(true,'both',true,3);	
    else
        makeResponsive(true,'both',true,1);	

    fnStartAnimation();

}
function getMobileOperatingSystem() {
    var userAgent = navigator.userAgent || navigator.vendor || window.opera;
    if (navigator.userAgent.indexOf('Safari') != -1 && navigator.userAgent.indexOf('Chrome') == -1){
        // safari
        console.log("it's safari");
        isMobile = true;
        detectDevice = "IOS";
    }
    // Windows Phone must come first because its UA also contains "Android"
    if (/windows phone/i.test(userAgent)) {
        //windows
    }
    if (/android/i.test(userAgent)) {
        // android
        detectDevice = "Android";
    }
    if (/iPad|iPhone|iPod/.test(userAgent) && !window.MSStream) {
        detectDevice = "IOS";
    }
}



var gameName = "baby-hazel-african-safari";
var game  = new Game(gameName); //new 
window.onload = function(){
    console.log("onload")
    game.loadVerionInfo(game.onLoadVersionInfo);   
}

